// CardGameEx8.java

import ch.aplu.jcardgame.*;
import ch.aplu.jgamegrid.*;

public class CardGameEx8 extends CardGame
{
  public enum Suit
  {
    KREUZ, KARO, HERZ, PIK
  }

  public enum Rank
  {
    ASS, KOENIG, DAME, BUBE, ZEHN, NEUN, ACHT, SIEBEN, SECHS
  }
  private Deck deck = new Deck(Suit.values(), Rank.values(), "cover");
  private Hand[] hands;
  private final Location left = new Location(150, 300);
  private final Location right = new Location(450, 300);

  public CardGameEx8()
  {
    super(600, 600, 30);
    setStatusText("Click on a card to move it");
    hands = deck.dealingOut(1, 0, false);  // Ordered

    CardAdapter cardAdapter = new CardAdapter()
    {
      public void leftPressed(Card card)
      {
        Hand targetHand;
        card.setVerso(!card.isVerso());
        if (card.isInHand(hands[0]))
          targetHand = hands[1];
        else
          targetHand = hands[0];
        card.transfer(targetHand, true);
      }
    };

    StackLayout stackLayout1 = new StackLayout(left);
    hands[1].setView(this, stackLayout1);
    hands[1].draw();
    hands[1].setVerso(true);
    StackLayout stackLayout2 = new StackLayout(right);
    hands[0].setView(this, stackLayout2);
    hands[0].draw();
   
    //add listener to both hands:
    for (Hand hand : hands)
    {
      hand.addCardListener(cardAdapter);
      hand.setTouchEnabled(true);
    }
  }

  public static void main(String[] args)
  {
    new CardGameEx8();
  }
}
